Instrument Class Referenceabstract

Abstract instrument class. More...

`#include <ql/instrument.hpp>`

Inheritance diagram for Instrument:
[legend]

## Public Member Functions

Inspectors
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
virtual bool | isExpired () const =0
| returns whether the instrument might have value greater than zero.
Modifiers
void | setPricingEngine (const ext::shared_ptr< PricingEngine > &)
| set the pricing engine to be used. More...
virtual void | setupArguments (PricingEngine::arguments *) const
virtual void | fetchResults (const PricingEngine::results *) const
Public Member Functions inherited from LazyObject
void | update ()
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()

## Protected Member Functions

Calculations
void | calculate () const
virtual void | setupExpired () const
virtual void | performCalculations () const
Protected Member Functions inherited from LazyObject

## Protected Attributes

Results
The value of this attribute and any other that derived classes might declare must be set during calculation.
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_
ext::shared_ptr< PricingEngine > | engine_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Additional Inherited Members

Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator

## Detailed Description

Abstract instrument class.

This class is purely abstract and defines the interface of concrete instruments which will be derived from this one.

Tests:
  observability of class instances is checked.

## Member Function Documentation

## setPricingEngine()

void setPricingEngine | ( | const ext::shared_ptr< PricingEngine > & | e | ) |

set the pricing engine to be used.

Warning:
  calling this method will have no effects in case the performCalculation method was overridden in a derived class.

## setupArguments()

void setupArguments | ( | PricingEngine::arguments * |  | ) | const

virtual

When a derived argument structure is defined for an instrument, this method should be overridden to fill it. This is mandatory in case a pricing engine is used.

Reimplemented in YearOnYearInflationSwap, VarianceSwap, VanillaSwap, NonstandardSwap, FloatFloatSwap, CPISwap, AssetSwap, VarianceOption, IrregularSwap, CallableFixedRateBond, Option, ZeroCouponInflationSwap, VanillaSwingOption, VanillaStorageOption, Swaption, Swap, NonstandardSwaption, MultiAssetOption, ContinuousPartialFixedLookbackOption, ContinuousPartialFloatingLookbackOption, ContinuousFixedLookbackOption, ContinuousFloatingLookbackOption, YoYInflationCapFloor, ForwardVanillaOption, FloatFloatSwaption, DividendVanillaOption, DividendBarrierOption, CreditDefaultSwap, CPICapFloor, CliquetOption, CapFloor, Bond, BarrierOption, DiscreteAveragingAsianOption, ContinuousAveragingAsianOption, IrregularSwaption, PathMultiAssetOption, WriterExtensibleOption, TwoAssetBarrierOption, SimpleChooserOption, PagodaOption, MargrabeOption, HimalayaOption, CompoundOption, SyntheticCDO, NthToDefault, CdsOption, EnergyCommodity, and DoubleBarrierOption.

## fetchResults()

void fetchResults | ( | const PricingEngine::results * | r | ) | const

virtual

When a derived result structure is defined for an instrument, this method should be overridden to read from it. This is mandatory in case a pricing engine is used.

Reimplemented in ZeroCouponInflationSwap, CPICapFloor, YearOnYearInflationSwap, VarianceSwap, VanillaSwap, Swap, QuantoVanillaOption, QuantoForwardVanillaOption, QuantoBarrierOption, OneAssetOption, NonstandardSwap, MultiAssetOption, ForwardVanillaOption, FloatFloatSwap, CreditDefaultSwap, CPISwap, Bond, AssetSwap, IrregularSwap, MargrabeOption, SyntheticCDO, NthToDefault, EnergyCommodity, and QuantoDoubleBarrierOption.

## calculate()

void calculate | ( |  | ) | const

protected virtual

This method performs all needed calculations by calling the performCalculations method.

Warning:
  Objects cache the results of the previous calculation. Such results will be returned upon later invocations of calculate. When the results depend on arguments which could change between invocations, the lazy object must register itself as observer of such objects for the calculations to be performed again when they change.

Warning:
  Should this method be redefined in derived classes, LazyObject::calculate() should be called in the overriding method.

Reimplemented from LazyObject.

## setupExpired()

void setupExpired | ( |  | ) | const

protected virtual

This method must leave the instrument in a consistent state when the expiration condition is met.

Reimplemented in VarianceSwap, Swap, OneAssetOption, MultiAssetOption, ForwardRateAgreement, CreditDefaultSwap, Bond, PathMultiAssetOption, and RiskyBond.

## performCalculations()

void performCalculations | ( |  | ) | const

protected virtual

In case a pricing engine is not used, this method must be overridden to perform the actual calculations and set any needed results. In case a pricing engine is used, the default implementation can be used.

Implements LazyObject.

Reimplemented in Stock, ForwardRateAgreement, Forward, FixedRateBondForward, CompositeInstrument, RiskyBond, ConvertibleBond, EnergyVanillaSwap, EnergyFuture, and EnergyBasisSwap.